#ifndef __CURSOR__
#define __CURSOR__

#include <windows.h>
#include <gl\gl.h>
#include <assert.h>

#include "log.h"
#include "globals.h"
#include "textures.h"

class cursor_t
{
public:
	cursor_t( int aTexture = 0 ) : mEnabled( true ), mTexture( aTexture ), 
		mScreenWidth( 1024 ), mScreenHeight( 768 ) {}
	~cursor_t() {}

	void set_texture( int aTexture ) { mTexture = aTexture; }

	void set_dim( int aWidth, int aHeight )
	{ mScreenWidth = aWidth; mScreenHeight = aHeight; }

	void draw();

  void enable() { mEnabled = true; }
  void disable() { mEnabled = false; }
  bool get_enable() const { return mEnabled; }

private:
  bool mEnabled;

	int mTexture;
	int mScreenWidth, mScreenHeight;
};

extern cursor_t gCursor;

#endif