#ifndef __FONT__
#define __FONT__

#include "textures.h"
#include "glext.h"
#include "log.h"
#include "globals.h"

class texture_manager_t;

class font_t
{
public:
	font_t() : mWidth( 16 ), mHeight( 16 ), mSpace( 10 ) {}
	~font_t() { kill(); }

  void build( texture_manager_t *apTextures );
  
	void print( float aX, float aY, const char *aStr ) const;
  
	void print( float aX, float aY, float aR, float aG, float aB,
		        const char *aStr ) const;

	void pre() const;
	void post() const;

	void setDim( float aWidth, float aHeight, float aSpace ) 
    { mWidth = aWidth; mHeight = aHeight; mSpace = aSpace; }

	float getSpace() const { return mSpace; }

	void setDefaultDim()
	{
		mWidth = mHeight = 16;
		mSpace = 10;
	}

private:

  void kill() {}
	
	// Font LUT's
	float mXArr[ 256 ];
	float mYArr[ 256 ];

	int mFontID;

	float mWidth, mHeight, mSpace;
};

#endif
