#include "glext.h"

// Extension functions
PFNGLACTIVETEXTUREARBPROC glActiveTextureARB = 0;
PFNGLMULTITEXCOORD2FARBPROC glMultiTexCoord2fARB = 0;
PFNGLCLIENTACTIVETEXTUREARBPROC glClientActiveTextureARB = 0;

PFNGLLOCKARRAYSEXTPROC glLockArrays = 0;
PFNGLUNLOCKARRAYSEXTPROC glUnlockArrays = 0;

//Simple macro to make it easy to get function pointers
//(credit to Shawn Kirst)
#ifdef _WIN32
# define GLPROC(type,func) (func)=(type)wglGetProcAddress(#func)
#else
# define GLPROC(type,func) (func)=(type)glXGetProcAddressARB((GLubyte*)#func)
#endif

PFNGLSTENCILOPSEPARATEATIPROC glStencilOpSeparateATI=0;
PFNGLSTENCILFUNCSEPARATEATIPROC glStencilFuncSeparateATI=0;

PFNGLACTIVESTENCILFACEEXTPROC glActiveStencilFaceEXT=0;

//The actual function pointer instances.
PFNGLVERTEXATTRIB1SARB glVertexAttrib1sARB;
PFNGLVERTEXATTRIB1FARB glVertexAttrib1fARB;
PFNGLVERTEXATTRIB1DARB glVertexAttrib1dARB;
PFNGLVERTEXATTRIB2SARB glVertexAttrib2sARB;
PFNGLVERTEXATTRIB2FARB glVertexAttrib2fARB;
PFNGLVERTEXATTRIB2DARB glVertexAttrib2dARB;
PFNGLVERTEXATTRIB3SARB glVertexAttrib3sARB;
PFNGLVERTEXATTRIB3FARB glVertexAttrib3fARB;
PFNGLVERTEXATTRIB3DARB glVertexAttrib3dARB;
PFNGLVERTEXATTRIB4SARB glVertexAttrib4sARB;
PFNGLVERTEXATTRIB4FARB glVertexAttrib4fARB;
PFNGLVERTEXATTRIB4DARB glVertexAttrib4dARB;
PFNGLVERTEXATTRIB4NUBARB glVertexAttrib4NubARB;

PFNGLVERTEXATTRIB1SVARB glVertexAttrib1svARB;
PFNGLVERTEXATTRIB1FVARB glVertexAttrib1fvARB;
PFNGLVERTEXATTRIB1DVARB glVertexAttrib1dvARB;
PFNGLVERTEXATTRIB2SVARB glVertexAttrib2svARB;
PFNGLVERTEXATTRIB2FVARB glVertexAttrib2fvARB;
PFNGLVERTEXATTRIB2DVARB glVertexAttrib2dvARB;
PFNGLVERTEXATTRIB3SVARB glVertexAttrib3svARB;
PFNGLVERTEXATTRIB3FVARB glVertexAttrib3fvARB;
PFNGLVERTEXATTRIB3DVARB glVertexAttrib3dvARB;
PFNGLVERTEXATTRIB4BVARB glVertexAttrib4bvARB;
PFNGLVERTEXATTRIB4SVARB glVertexAttrib4svARB;
PFNGLVERTEXATTRIB4IVARB glVertexAttrib4ivARB;
PFNGLVERTEXATTRIB4UBVARB glVertexAttrib4ubvARB;
PFNGLVERTEXATTRIB4USVARB glVertexAttrib4usvARB;
PFNGLVERTEXATTRIB4UIVARB glVertexAttrib4uivARB;
PFNGLVERTEXATTRIB4FVARB glVertexAttrib4fvARB;
PFNGLVERTEXATTRIB4DVARB glVertexAttrib4dvARB;
PFNGLVERTEXATTRIB4NBVARB glVertexAttrib4NbvARB;
PFNGLVERTEXATTRIB4NSVARB glVertexAttrib4NsvARB;
PFNGLVERTEXATTRIB4NIVARB glVertexAttrib4NivARB;
PFNGLVERTEXATTRIB4NUBVARB glVertexAttrib4NubvARB;
PFNGLVERTEXATTRIB4NUSVARB glVertexAttrib4NusvARB;
PFNGLVERTEXATTRIB4NUIVARB glVertexAttrib4NuivARB;

PFNGLVERTEXATTRIBPOINTERARB glVertexAttribPointerARB;
PFNGLENABLEVERTEXATTRIBARRAYARB glEnableVertexAttribArrayARB;
PFNGLDISABLEVERTEXATTRIBARRAYARB glDisableVertexAttribArrayARB;
PFNGLPROGRAMSTRINGARB glProgramStringARB;
PFNGLBINDPROGRAMARB glBindProgramARB;
PFNGLDELETEPROGRAMSARB glDeleteProgramsARB;
PFNGLGENPROGRAMSARB glGenProgramsARB;

PFNGLPROGRAMENVPARAMETER4DARB glProgramEnvParameter4dARB;
PFNGLPROGRAMENVPARAMETER4DVARB glProgramEnvParameter4dvARB;
PFNGLPROGRAMENVPARAMETER4FARB glProgramEnvParameter4fARB;
PFNGLPROGRAMENVPARAMETER4FVARB glProgramEnvParameter4fvARB;

PFNGLPROGRAMLOCALPARAMETER4DARB glProgramLocalParameter4dARB;
PFNGLPROGRAMLOCALPARAMETER4DVARB glProgramLocalParameter4dvARB;
PFNGLPROGRAMLOCALPARAMETER4FARB glProgramLocalParameter4fARB;
PFNGLPROGRAMLOCALPARAMETER4FVARB glProgramLocalParameter4fvARB;

PFNGLGETPROGRAMENVPARAMETERDVARB glGetProgramEnvParameterdvARB;
PFNGLGETPROGRAMENVPARAMETERFVARB glGetProgramEnvParameterfvARB;

PFNGLGETPROGRAMLOCALPARAMETERDVARB glGetProgramLocalParameterdvARB;
PFNGLGETPROGRAMLOCALPARAMETERFVARB glGetProgramLocalParameterfvARB;

PFNGLGETPROGRAMIVARB glGetProgramivARB;
PFNGLGETPROGRAMSTRINGARB glGetProgramStringARB;
PFNGLGETVERTEXATTRIBDVARB glGetVertexAttribdvARB;
PFNGLGETVERTEXATTRIBFVARB glGetVertexAttribfvARB;
PFNGLGETVERTEXATTRIBIVARB glGetVertexAttribivARB;
PFNGLGETVERTEXATTRIBPOINTERVARB glGetVertexAttribPointervARB;
PFNGLISPROGRAMARB glIsProgramARB;

//Checks to see if a extension exists in the ext string
bool 
check_extension( const char *ext )
{
	char* extstring=0;
	
	extstring = new char[strlen((char*)glGetString(GL_EXTENSIONS)) + 1];
	strcpy(extstring,(char*)glGetString(GL_EXTENSIONS));

	if (strstr(extstring,ext)) 
	{
		delete [] extstring;
		return true;
	}

	delete [] extstring;
	return false;
}


//Initializes all of the ARB VP functions
bool 
init_vertex_program_arb()
{
	if ( check_extension( "GL_ARB_vertex_program" ) )
	{
	  glVertexAttrib1sARB = (PFNGLVERTEXATTRIB1SARB) wglGetProcAddress("glVertexAttrib1sARB");
	  glVertexAttrib1fARB = (PFNGLVERTEXATTRIB1FARB) wglGetProcAddress("glVertexAttrib1fARB");
	  glVertexAttrib1dARB = (PFNGLVERTEXATTRIB1DARB) wglGetProcAddress("glVertexAttrib1dARB");
	  glVertexAttrib2sARB = (PFNGLVERTEXATTRIB2SARB) wglGetProcAddress("glVertexAttrib2sARB");
	  glVertexAttrib2fARB = (PFNGLVERTEXATTRIB2FARB) wglGetProcAddress("glVertexAttrib2fARB");
	  glVertexAttrib2dARB = (PFNGLVERTEXATTRIB2DARB) wglGetProcAddress("glVertexAttrib2dARB");
	  glVertexAttrib3sARB = (PFNGLVERTEXATTRIB3SARB) wglGetProcAddress("glVertexAttrib3sARB");
	  glVertexAttrib3fARB = (PFNGLVERTEXATTRIB3FARB) wglGetProcAddress("glVertexAttrib3fARB");
	  glVertexAttrib3dARB = (PFNGLVERTEXATTRIB3DARB) wglGetProcAddress("glVertexAttrib3dARB");
	  glVertexAttrib4sARB = (PFNGLVERTEXATTRIB4SARB) wglGetProcAddress("glVertexAttrib4sARB");
	  glVertexAttrib4fARB = (PFNGLVERTEXATTRIB4FARB) wglGetProcAddress("glVertexAttrib4fARB");
	  glVertexAttrib4dARB = (PFNGLVERTEXATTRIB4DARB) wglGetProcAddress("glVertexAttrib4dARB");
	  glVertexAttrib4NubARB = (PFNGLVERTEXATTRIB4NUBARB) wglGetProcAddress("glVertexAttrib4NubARB");
	  glVertexAttrib1svARB = (PFNGLVERTEXATTRIB1SVARB) wglGetProcAddress("glVertexAttrib1svARB");
	  glVertexAttrib1fvARB = (PFNGLVERTEXATTRIB1FVARB) wglGetProcAddress("glVertexAttrib1fvARB");
	  glVertexAttrib1dvARB = (PFNGLVERTEXATTRIB1DVARB) wglGetProcAddress("glVertexAttrib1dvARB");
	  glVertexAttrib2svARB = (PFNGLVERTEXATTRIB2SVARB) wglGetProcAddress("glVertexAttrib2svARB");
	  glVertexAttrib2fvARB = (PFNGLVERTEXATTRIB2FVARB) wglGetProcAddress("glVertexAttrib2fvARB");
	  glVertexAttrib2dvARB = (PFNGLVERTEXATTRIB2DVARB) wglGetProcAddress("glVertexAttrib2dvARB");
	  glVertexAttrib3svARB = (PFNGLVERTEXATTRIB3SVARB) wglGetProcAddress("glVertexAttrib3svARB");
	  glVertexAttrib3fvARB = (PFNGLVERTEXATTRIB3FVARB) wglGetProcAddress("glVertexAttrib3fvARB");
	  glVertexAttrib3dvARB = (PFNGLVERTEXATTRIB3DVARB) wglGetProcAddress("glVertexAttrib3dvARB");
	  glVertexAttrib4bvARB = (PFNGLVERTEXATTRIB4BVARB) wglGetProcAddress("glVertexAttrib4bvARB");
	  glVertexAttrib4svARB = (PFNGLVERTEXATTRIB4SVARB) wglGetProcAddress("glVertexAttrib4svARB");
	  glVertexAttrib4ivARB = (PFNGLVERTEXATTRIB4IVARB) wglGetProcAddress("glVertexAttrib4ivARB");
	  glVertexAttrib4ubvARB = (PFNGLVERTEXATTRIB4UBVARB) wglGetProcAddress("glVertexAttrib4ubvARB");
	  glVertexAttrib4usvARB = (PFNGLVERTEXATTRIB4USVARB) wglGetProcAddress("glVertexAttrib4usvARB");
	  glVertexAttrib4uivARB = (PFNGLVERTEXATTRIB4UIVARB) wglGetProcAddress("glVertexAttrib4uivARB");
	  glVertexAttrib4fvARB = (PFNGLVERTEXATTRIB4FVARB) wglGetProcAddress("glVertexAttrib4fvARB");
	  glVertexAttrib4dvARB = (PFNGLVERTEXATTRIB4DVARB) wglGetProcAddress("glVertexAttrib4dvARB");
	  glVertexAttrib4NbvARB = (PFNGLVERTEXATTRIB4NBVARB) wglGetProcAddress("glVertexAttrib4NbvARB");
	  glVertexAttrib4NsvARB = (PFNGLVERTEXATTRIB4NSVARB) wglGetProcAddress("glVertexAttrib4NsvARB");
	  glVertexAttrib4NivARB = (PFNGLVERTEXATTRIB4NIVARB) wglGetProcAddress("glVertexAttrib4NivARB");
	  glVertexAttrib4NubvARB = (PFNGLVERTEXATTRIB4NUBVARB) wglGetProcAddress("glVertexAttrib4NubvARB");
	  glVertexAttrib4NusvARB = (PFNGLVERTEXATTRIB4NUSVARB) wglGetProcAddress("glVertexAttrib4NusvARB");
	  glVertexAttrib4NuivARB = (PFNGLVERTEXATTRIB4NUIVARB) wglGetProcAddress("glVertexAttrib4NuivARB");
	  glVertexAttribPointerARB = (PFNGLVERTEXATTRIBPOINTERARB) wglGetProcAddress("glVertexAttribPointerARB");
	  glEnableVertexAttribArrayARB = (PFNGLENABLEVERTEXATTRIBARRAYARB) wglGetProcAddress("glEnableVertexAttribArrayARB");
	  glDisableVertexAttribArrayARB = (PFNGLDISABLEVERTEXATTRIBARRAYARB) wglGetProcAddress("glDisableVertexAttribArrayARB");
	  glProgramStringARB = (PFNGLPROGRAMSTRINGARB) wglGetProcAddress("glProgramStringARB");
	  glBindProgramARB = (PFNGLBINDPROGRAMARB) wglGetProcAddress("glBindProgramARB");
	  glDeleteProgramsARB = (PFNGLDELETEPROGRAMSARB) wglGetProcAddress("glDeleteProgramsARB");
	  glGenProgramsARB = (PFNGLGENPROGRAMSARB) wglGetProcAddress("glGenProgramsARB");
	  glProgramEnvParameter4dARB = (PFNGLPROGRAMENVPARAMETER4DARB) wglGetProcAddress("glProgramEnvParameter4dARB");
	  glProgramEnvParameter4dvARB = (PFNGLPROGRAMENVPARAMETER4DVARB) wglGetProcAddress("glProgramEnvParameter4dvARB");
	  glProgramEnvParameter4fARB = (PFNGLPROGRAMENVPARAMETER4FARB) wglGetProcAddress("glProgramEnvParameter4fARB");
	  glProgramEnvParameter4fvARB = (PFNGLPROGRAMENVPARAMETER4FVARB) wglGetProcAddress("glProgramEnvParameter4fvARB");
	  glProgramLocalParameter4dARB = (PFNGLPROGRAMLOCALPARAMETER4DARB) wglGetProcAddress("glProgramLocalParameter4dARB");
	  glProgramLocalParameter4dvARB = (PFNGLPROGRAMLOCALPARAMETER4DVARB) wglGetProcAddress("glProgramLocalParameter4dvARB");
	  glProgramLocalParameter4fARB = (PFNGLPROGRAMLOCALPARAMETER4FARB) wglGetProcAddress("glProgramLocalParameter4fARB");
	  glProgramLocalParameter4fvARB = (PFNGLPROGRAMLOCALPARAMETER4FVARB) wglGetProcAddress("glProgramLocalParameter4fvARB");
	  glGetProgramEnvParameterdvARB = (PFNGLGETPROGRAMENVPARAMETERDVARB) wglGetProcAddress("glGetProgramEnvParameterdvARB");
	  glGetProgramEnvParameterfvARB = (PFNGLGETPROGRAMENVPARAMETERFVARB) wglGetProcAddress("glGetProgramEnvParameterfvARB");
	  glGetProgramLocalParameterdvARB = (PFNGLGETPROGRAMLOCALPARAMETERDVARB) wglGetProcAddress("glGetProgramLocalParameterdvARB");
	  glGetProgramLocalParameterfvARB = (PFNGLGETPROGRAMLOCALPARAMETERFVARB) wglGetProcAddress("glGetProgramLocalParameterfvARB");
	  glGetProgramivARB = (PFNGLGETPROGRAMIVARB) wglGetProcAddress("glGetProgramivARB");
	  glGetProgramStringARB = (PFNGLGETPROGRAMSTRINGARB) wglGetProcAddress("glGetProgramStringARB");
	  glGetVertexAttribdvARB = (PFNGLGETVERTEXATTRIBDVARB) wglGetProcAddress("glGetVertexAttribdvARB");
	  glGetVertexAttribfvARB = (PFNGLGETVERTEXATTRIBFVARB) wglGetProcAddress("glGetVertexAttribfvARB");
	  glGetVertexAttribivARB = (PFNGLGETVERTEXATTRIBIVARB) wglGetProcAddress("glGetVertexAttribivARB");
	  glGetVertexAttribPointervARB = (PFNGLGETVERTEXATTRIBPOINTERVARB) wglGetProcAddress("glGetVertexAttribPointervARB");
	  glIsProgramARB = (PFNGLISPROGRAMARB) wglGetProcAddress("glIsProgramARB");		  

		return true;
	}
  
  return false;
}

bool 
init_fragment_program_arb()
{
  if ( check_extension( "GL_ARB_fragment_program" ) )
	{
    // Functions get initialized by the vertex program extension
    return true;
  }

  return false;
}

bool 
init_separate_stencil_ati()
{
  if ( check_extension( "GL_ATI_separate_stencil" ) )
  {
    GLPROC(PFNGLSTENCILOPSEPARATEATIPROC,glStencilOpSeparateATI);
    GLPROC(PFNGLSTENCILFUNCSEPARATEATIPROC,glStencilFuncSeparateATI);
    return true;
  }

  return false;
}

bool 
init_stencil_two_side_ext()
{
  if ( check_extension( "GL_EXT_stencil_two_side" ) )
  {
    GLPROC(PFNGLACTIVESTENCILFACEEXTPROC,glActiveStencilFaceEXT);
    return true;
  }

  return false;
}

bool 
init_multitexture_arb()
{
	if ( check_extension( "GL_ARB_multitexture" ) )
	{
		GLPROC(PFNGLACTIVETEXTUREARBPROC,glActiveTextureARB);
		GLPROC(PFNGLMULTITEXCOORD2FARBPROC,glMultiTexCoord2fARB);
		GLPROC(PFNGLCLIENTACTIVETEXTUREARBPROC,glClientActiveTextureARB);
		return true;
	}
	else
	{
		return false;
	}
}

bool 
init_compiled_vertex_array_ext()
{
	if ( check_extension( "GL_EXT_compiled_vertex_array" ) )
	{
		glLockArrays = ( PFNGLLOCKARRAYSEXTPROC ) wglGetProcAddress( "glLockArraysEXT" );
		glUnlockArrays = ( PFNGLUNLOCKARRAYSEXTPROC ) wglGetProcAddress( "glUnlockArraysEXT" );
		return true;
	}
	else
	{
		return false;
	}
}
