#ifndef __glext_h_
#define __glext_h_

#ifdef __cplusplus
extern "C" {
#endif

/*
** Copyright 1992-1999 Silicon Graphics, Inc.
** All Rights Reserved.
**
** This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
** the contents of this file may not be disclosed to third parties, copied or
** duplicated in any form, in whole or in part, without the prior written
** permission of Silicon Graphics, Inc.
**
** RESTRICTED RIGHTS LEGEND:
** Use, duplication or disclosure by the Government is subject to restrictions
** as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
** and Computer Software clause at DFARS 252.227-7013, and/or in similar or
** successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
** rights reserved under the Copyright Laws of the United States.
*/

#ifndef APIENTRY
#define WIN32_LEAN_AND_MEAN 1
#include <windows.h>
#endif

#include <gl\gl.h>			// Header File For The OpenGL32 Library

#define GL_ARB_multitexture                 1
#define GL_EXT_abgr                         1
#define GL_EXT_bgra                         1
#define GL_EXT_clip_volume_hint             1
#define GL_EXT_compiled_vertex_array        1
#define GL_EXT_cull_vertex                  1
#define GL_EXT_packed_pixels                1
#define GL_EXT_point_parameters             1
#define GL_EXT_stencil_wrap                 1
#define GL_EXT_texture_env_add              1
#define GL_EXT_texture_env_combine          1
#define GL_EXT_vertex_array                 1
#define GL_NV_texgen_reflection             1
#define GL_NV_texture_env_combine4          1
#define GL_WIN_swap_hint                    1
#define GL_NV_vertex_program              1

#define GL_ARB_texture_compression          1

#define GL_COMPRESSED_ALPHA_ARB           0x84E9
#define GL_COMPRESSED_LUMINANCE_ARB       0x84EA
#define GL_COMPRESSED_LUMINANCE_ALPHA_ARB 0x84EB
#define GL_COMPRESSED_INTENSITY_ARB       0x84EC
#define GL_COMPRESSED_RGB_ARB             0x84ED
#define GL_COMPRESSED_RGBA_ARB            0x84EE
#define GL_TEXTURE_COMPRESSION_HINT_ARB   0x84EF
#define GL_TEXTURE_IMAGE_SIZE_ARB         0x86A0
#define GL_TEXTURE_COMPRESSED_ARB         0x86A1
#define GL_NUM_COMPRESSED_TEXTURE_FORMATS_ARB 0x86A2
#define GL_COMPRESSED_TEXTURE_FORMATS_ARB 0x86A3

/* EXT_abgr */
#define GL_ABGR_EXT                         0x8000
#define GL_BGR_EXT                          0x80E0
#define GL_BGRA_EXT                         0x80E1

/* EXT_packed_pixels */
#define GL_UNSIGNED_BYTE_3_3_2_EXT          0x8032
#define GL_UNSIGNED_SHORT_4_4_4_4_EXT       0x8033
#define GL_UNSIGNED_SHORT_5_5_5_1_EXT       0x8034
#define GL_UNSIGNED_INT_8_8_8_8_EXT         0x8035
#define GL_UNSIGNED_INT_10_10_10_2_EXT      0x8036

/* EXT_vertex_array */
#define GL_VERTEX_ARRAY_EXT                 0x8074
#define GL_NORMAL_ARRAY_EXT                 0x8075
#define GL_COLOR_ARRAY_EXT                  0x8076
#define GL_INDEX_ARRAY_EXT                  0x8077
#define GL_TEXTURE_COORD_ARRAY_EXT          0x8078
#define GL_EDGE_FLAG_ARRAY_EXT              0x8079
#define GL_VERTEX_ARRAY_SIZE_EXT            0x807A
#define GL_VERTEX_ARRAY_TYPE_EXT            0x807B
#define GL_VERTEX_ARRAY_STRIDE_EXT          0x807C
#define GL_VERTEX_ARRAY_COUNT_EXT           0x807D
#define GL_NORMAL_ARRAY_TYPE_EXT            0x807E
#define GL_NORMAL_ARRAY_STRIDE_EXT          0x807F
#define GL_NORMAL_ARRAY_COUNT_EXT           0x8080
#define GL_COLOR_ARRAY_SIZE_EXT             0x8081
#define GL_COLOR_ARRAY_TYPE_EXT             0x8082
#define GL_COLOR_ARRAY_STRIDE_EXT           0x8083
#define GL_COLOR_ARRAY_COUNT_EXT            0x8084
#define GL_INDEX_ARRAY_TYPE_EXT             0x8085
#define GL_INDEX_ARRAY_STRIDE_EXT           0x8086
#define GL_INDEX_ARRAY_COUNT_EXT            0x8087
#define GL_TEXTURE_COORD_ARRAY_SIZE_EXT     0x8088
#define GL_TEXTURE_COORD_ARRAY_TYPE_EXT     0x8089
#define GL_TEXTURE_COORD_ARRAY_STRIDE_EXT   0x808A
#define GL_TEXTURE_COORD_ARRAY_COUNT_EXT    0x808B
#define GL_EDGE_FLAG_ARRAY_STRIDE_EXT       0x808C
#define GL_EDGE_FLAG_ARRAY_COUNT_EXT        0x808D
#define GL_VERTEX_ARRAY_POINTER_EXT         0x808E
#define GL_NORMAL_ARRAY_POINTER_EXT         0x808F
#define GL_COLOR_ARRAY_POINTER_EXT          0x8090
#define GL_INDEX_ARRAY_POINTER_EXT          0x8091
#define GL_TEXTURE_COORD_ARRAY_POINTER_EXT  0x8092
#define GL_EDGE_FLAG_ARRAY_POINTER_EXT      0x8093

/* EXT_bgra */
#define GL_BGR_EXT                          0x80E0
#define GL_BGRA_EXT                         0x80E1

/* EXT_clip_volume_hint */
#define GL_CLIP_VOLUME_CLIPPING_HINT_EXT    0x80F0

/* EXT_point_parameters */
#define GL_POINT_SIZE_MIN_EXT               0x8126
#define GL_POINT_SIZE_MAX_EXT               0x8127
#define GL_POINT_FADE_THRESHOLD_SIZE_EXT    0x8128
#define GL_DISTANCE_ATTENUATION_EXT         0x8129

/* EXT_compiled_vertex_array */
#define GL_ARRAY_ELEMENT_LOCK_FIRST_EXT     0x81A8
#define GL_ARRAY_ELEMENT_LOCK_COUNT_EXT     0x81A9

/* EXT_cull_vertex */
#define GL_CULL_VERTEX_EXT                  0x81AA
#define GL_CULL_VERTEX_EYE_POSITION_EXT     0x81AB
#define GL_CULL_VERTEX_OBJECT_POSITION_EXT  0x81AC

/* ARB_multitexture */
#define GL_ACTIVE_TEXTURE_ARB               0x84E0
#define GL_CLIENT_ACTIVE_TEXTURE_ARB        0x84E1
#define GL_MAX_TEXTURE_UNITS_ARB            0x84E2
#define GL_TEXTURE0_ARB                     0x84C0
#define GL_TEXTURE1_ARB                     0x84C1
#define GL_TEXTURE2_ARB                     0x84C2
#define GL_TEXTURE3_ARB                     0x84C3
#define GL_TEXTURE4_ARB                     0x84C4
#define GL_TEXTURE5_ARB                     0x84C5
#define GL_TEXTURE6_ARB                     0x84C6
#define GL_TEXTURE7_ARB                     0x84C7
#define GL_TEXTURE8_ARB                     0x84C8
#define GL_TEXTURE9_ARB                     0x84C9
#define GL_TEXTURE10_ARB                    0x84CA
#define GL_TEXTURE11_ARB                    0x84CB
#define GL_TEXTURE12_ARB                    0x84CC
#define GL_TEXTURE13_ARB                    0x84CD
#define GL_TEXTURE14_ARB                    0x84CE
#define GL_TEXTURE15_ARB                    0x84CF
#define GL_TEXTURE16_ARB                    0x84D0
#define GL_TEXTURE17_ARB                    0x84D1
#define GL_TEXTURE18_ARB                    0x84D2
#define GL_TEXTURE19_ARB                    0x84D3
#define GL_TEXTURE20_ARB                    0x84D4
#define GL_TEXTURE21_ARB                    0x84D5
#define GL_TEXTURE22_ARB                    0x84D6
#define GL_TEXTURE23_ARB                    0x84D7
#define GL_TEXTURE24_ARB                    0x84D8
#define GL_TEXTURE25_ARB                    0x84D9
#define GL_TEXTURE26_ARB                    0x84DA
#define GL_TEXTURE27_ARB                    0x84DB
#define GL_TEXTURE28_ARB                    0x84DC
#define GL_TEXTURE29_ARB                    0x84DD
#define GL_TEXTURE30_ARB                    0x84DE
#define GL_TEXTURE31_ARB                    0x84DF

/* EXT_stencil_wrap */
#define GL_INCR_WRAP_EXT                    0x8507
#define GL_DECR_WRAP_EXT                    0x8508

/* NV_texgen_reflection */
#define GL_NORMAL_MAP_NV                    0x8511
#define GL_REFLECTION_MAP_NV                0x8512

/* EXT_texture_env_combine */
#define GL_COMBINE_EXT                      0x8570
#define GL_COMBINE_RGB_EXT                  0x8571
#define GL_COMBINE_ALPHA_EXT                0x8572
#define GL_RGB_SCALE_EXT                    0x8573
#define GL_ADD_SIGNED_EXT                   0x8574
#define GL_INTERPOLATE_EXT                  0x8575
#define GL_CONSTANT_EXT                     0x8576
#define GL_PRIMARY_COLOR_EXT                0x8577
#define GL_PREVIOUS_EXT                     0x8578
#define GL_SOURCE0_RGB_EXT                  0x8580
#define GL_SOURCE1_RGB_EXT                  0x8581
#define GL_SOURCE2_RGB_EXT                  0x8582
#define GL_SOURCE0_ALPHA_EXT                0x8588
#define GL_SOURCE1_ALPHA_EXT                0x8589
#define GL_SOURCE2_ALPHA_EXT                0x858A
#define GL_OPERAND0_RGB_EXT                 0x8590
#define GL_OPERAND1_RGB_EXT                 0x8591
#define GL_OPERAND2_RGB_EXT                 0x8592
#define GL_OPERAND0_ALPHA_EXT               0x8598
#define GL_OPERAND1_ALPHA_EXT               0x8599
#define GL_OPERAND2_ALPHA_EXT               0x859A

/* NV_texture_env_combine4 */
#define GL_COMBINE4_NV                      0x8503
#define GL_SOURCE3_RGB_NV                   0x8583
#define GL_SOURCE3_ALPHA_NV                 0x858B
#define GL_OPERAND3_RGB_NV                  0x8593
#define GL_OPERAND3_ALPHA_NV                0x859B

#define GL_CLAMP_TO_EDGE_SGIS               0x812F

/* EXT_vertex_array */
typedef void (APIENTRY * PFNGLARRAYELEMENTEXTPROC) (GLint i);
typedef void (APIENTRY * PFNGLCOLORPOINTEREXTPROC) (GLint size, GLenum type, GLsizei stride, GLsizei count, const GLvoid *pointer);
typedef void (APIENTRY * PFNGLDRAWARRAYSEXTPROC) (GLenum mode, GLint first, GLsizei count);
typedef void (APIENTRY * PFNGLEDGEFLAGPOINTEREXTPROC) (GLsizei stride, GLsizei count, const GLboolean *pointer);
typedef void (APIENTRY * PFNGLGETPOINTERVEXTPROC) (GLenum pname, GLvoid* *params);
typedef void (APIENTRY * PFNGLINDEXPOINTEREXTPROC) (GLenum type, GLsizei stride, GLsizei count, const GLvoid *pointer);
typedef void (APIENTRY * PFNGLNORMALPOINTEREXTPROC) (GLenum type, GLsizei stride, GLsizei count, const GLvoid *pointer);
typedef void (APIENTRY * PFNGLTEXCOORDPOINTEREXTPROC) (GLint size, GLenum type, GLsizei stride, GLsizei count, const GLvoid *pointer);
typedef void (APIENTRY * PFNGLVERTEXPOINTEREXTPROC) (GLint size, GLenum type, GLsizei stride, GLsizei count, const GLvoid *pointer);

/* ARB_multitexture */
typedef void (APIENTRY * PFNGLMULTITEXCOORD1DARBPROC) (GLenum target, GLdouble s);
typedef void (APIENTRY * PFNGLMULTITEXCOORD1DVARBPROC) (GLenum target, const GLdouble *v);
typedef void (APIENTRY * PFNGLMULTITEXCOORD1FARBPROC) (GLenum target, GLfloat s);
typedef void (APIENTRY * PFNGLMULTITEXCOORD1FVARBPROC) (GLenum target, const GLfloat *v);
typedef void (APIENTRY * PFNGLMULTITEXCOORD1IARBPROC) (GLenum target, GLint s);
typedef void (APIENTRY * PFNGLMULTITEXCOORD1IVARBPROC) (GLenum target, const GLint *v);
typedef void (APIENTRY * PFNGLMULTITEXCOORD1SARBPROC) (GLenum target, GLshort s);
typedef void (APIENTRY * PFNGLMULTITEXCOORD1SVARBPROC) (GLenum target, const GLshort *v);
typedef void (APIENTRY * PFNGLMULTITEXCOORD2DARBPROC) (GLenum target, GLdouble s, GLdouble t);
typedef void (APIENTRY * PFNGLMULTITEXCOORD2DVARBPROC) (GLenum target, const GLdouble *v);
typedef void (APIENTRY * PFNGLMULTITEXCOORD2FARBPROC) (GLenum target, GLfloat s, GLfloat t);
typedef void (APIENTRY * PFNGLMULTITEXCOORD2FVARBPROC) (GLenum target, const GLfloat *v);
typedef void (APIENTRY * PFNGLMULTITEXCOORD2IARBPROC) (GLenum target, GLint s, GLint t);
typedef void (APIENTRY * PFNGLMULTITEXCOORD2IVARBPROC) (GLenum target, const GLint *v);
typedef void (APIENTRY * PFNGLMULTITEXCOORD2SARBPROC) (GLenum target, GLshort s, GLshort t);
typedef void (APIENTRY * PFNGLMULTITEXCOORD2SVARBPROC) (GLenum target, const GLshort *v);
typedef void (APIENTRY * PFNGLMULTITEXCOORD3DARBPROC) (GLenum target, GLdouble s, GLdouble t, GLdouble r);
typedef void (APIENTRY * PFNGLMULTITEXCOORD3DVARBPROC) (GLenum target, const GLdouble *v);
typedef void (APIENTRY * PFNGLMULTITEXCOORD3FARBPROC) (GLenum target, GLfloat s, GLfloat t, GLfloat r);
typedef void (APIENTRY * PFNGLMULTITEXCOORD3FVARBPROC) (GLenum target, const GLfloat *v);
typedef void (APIENTRY * PFNGLMULTITEXCOORD3IARBPROC) (GLenum target, GLint s, GLint t, GLint r);
typedef void (APIENTRY * PFNGLMULTITEXCOORD3IVARBPROC) (GLenum target, const GLint *v);
typedef void (APIENTRY * PFNGLMULTITEXCOORD3SARBPROC) (GLenum target, GLshort s, GLshort t, GLshort r);
typedef void (APIENTRY * PFNGLMULTITEXCOORD3SVARBPROC) (GLenum target, const GLshort *v);
typedef void (APIENTRY * PFNGLMULTITEXCOORD4DARBPROC) (GLenum target, GLdouble s, GLdouble t, GLdouble r, GLdouble q);
typedef void (APIENTRY * PFNGLMULTITEXCOORD4DVARBPROC) (GLenum target, const GLdouble *v);
typedef void (APIENTRY * PFNGLMULTITEXCOORD4FARBPROC) (GLenum target, GLfloat s, GLfloat t, GLfloat r, GLfloat q);
typedef void (APIENTRY * PFNGLMULTITEXCOORD4FVARBPROC) (GLenum target, const GLfloat *v);
typedef void (APIENTRY * PFNGLMULTITEXCOORD4IARBPROC) (GLenum target, GLint s, GLint t, GLint r, GLint q);
typedef void (APIENTRY * PFNGLMULTITEXCOORD4IVARBPROC) (GLenum target, const GLint *v);
typedef void (APIENTRY * PFNGLMULTITEXCOORD4SARBPROC) (GLenum target, GLshort s, GLshort t, GLshort r, GLshort q);
typedef void (APIENTRY * PFNGLMULTITEXCOORD4SVARBPROC) (GLenum target, const GLshort *v);
typedef void (APIENTRY * PFNGLACTIVETEXTUREARBPROC) (GLenum target);
typedef void (APIENTRY * PFNGLCLIENTACTIVETEXTUREARBPROC) (GLenum target);

/* EXT_compiled_vertex_array */
typedef void (APIENTRY * PFNGLLOCKARRAYSEXTPROC) (GLint first, GLsizei count);
typedef void (APIENTRY * PFNGLUNLOCKARRAYSEXTPROC) (void);

/* EXT_cull_vertex */
typedef void (APIENTRY * PFNGLCULLPARAMETERDVEXTPROC) (GLenum pname, GLdouble* params);
typedef void (APIENTRY * PFNGLCULLPARAMETERFVEXTPROC) (GLenum pname, GLfloat* params);

/* WIN_swap_hint */
typedef void (APIENTRY * PFNGLADDSWAPHINTRECTWINPROC) (GLint x, GLint y, GLsizei width, GLsizei height);

/* EXT_point_parameter */
typedef void (APIENTRY * PFNGLPOINTPARAMETERFEXTPROC) (GLenum pname, GLfloat param);
typedef void (APIENTRY * PFNGLPOINTPARAMETERFVEXTPROC) (GLenum pname, const GLfloat *params);

// Extension functions
extern PFNGLACTIVETEXTUREARBPROC glActiveTextureARB;
extern PFNGLMULTITEXCOORD2FARBPROC glMultiTexCoord2fARB;
extern PFNGLCLIENTACTIVETEXTUREARBPROC glClientActiveTextureARB;

extern PFNGLLOCKARRAYSEXTPROC glLockArrays;
extern PFNGLUNLOCKARRAYSEXTPROC glUnlockArrays;

#ifndef GL_ATI_separate_stencil
#define GL_ATI_separate_stencil                     1

#define GL_STENCIL_BACK_FUNC_ATI                    0x8800
#define GL_STENCIL_BACK_FAIL_ATI                    0x8801
#define GL_STENCIL_BACK_PASS_DEPTH_FAIL_ATI         0x8802
#define GL_STENCIL_BACK_PASS_DEPTH_PASS_ATI         0x8803

typedef void (APIENTRY *PFNGLSTENCILOPSEPARATEATIPROC)(GLenum face, GLenum sfail, GLenum dpfail, GLenum dppass);
typedef void (APIENTRY *PFNGLSTENCILFUNCSEPARATEATIPROC)(GLenum frontfunc, GLenum backfunc, GLint ref, GLuint mask);

extern PFNGLSTENCILOPSEPARATEATIPROC glStencilOpSeparateATI;
extern PFNGLSTENCILFUNCSEPARATEATIPROC glStencilFuncSeparateATI;

#endif // GL_ATI_separate_stencil

#ifndef GL_EXT_stencil_two_side
#define GL_EXT_stencil_two_side                      1

#define GL_STENCIL_TEST_TWO_SIDE_EXT                 0x8910
#define GL_ACTIVE_STENCIL_FACE_EXT                   0x8911

typedef void (APIENTRY *PFNGLACTIVESTENCILFACEEXTPROC)(GLenum face);

extern PFNGLACTIVESTENCILFACEEXTPROC glActiveStencilFaceEXT;

#endif // GL_EXT_stencil_two_side

#define GL_VERTEX_PROGRAM_ARB                              0x8620

//Accepted by the <cap> parameter of Disable, Enable, and IsEnabled, and by
//the <pname> parameter of GetBooleanv, GetIntegerv, GetGLfloatv, and GetGLdoublev:

#define GL_VERTEX_PROGRAM_POINT_SIZE_ARB                   0x8642
#define GL_VERTEX_PROGRAM_TWO_SIDE_ARB                     0x8643
#define GL_COLOR_SUM_ARB                                   0x8458

//Accepted by the <format> parameter of ProgramStringARB:

#define GL_PROGRAM_FORMAT_ASCII_ARB                        0x8875

//Accepted by the <pname> parameter of GetVertexAttrib[dfi]vARB:

#define GL_VERTEX_ATTRIB_ARRAY_ENABLED_ARB                 0x8622
#define GL_VERTEX_ATTRIB_ARRAY_SIZE_ARB                    0x8623
#define GL_VERTEX_ATTRIB_ARRAY_STRIDE_ARB                  0x8624
#define GL_VERTEX_ATTRIB_ARRAY_TYPE_ARB                    0x8625
#define GL_VERTEX_ATTRIB_ARRAY_NORMALIZED_ARB              0x886A
#define GL_CURRENT_VERTEX_ATTRIB_ARB                       0x8626

//Accepted by the <pname> parameter of GetVertexAttribPointervARB:

#define GL_VERTEX_ATTRIB_ARRAY_POINTER_ARB                 0x8645

//Accepted by the <pname> parameter of GetProgramivARB:

#define GL_PROGRAM_LENGTH_ARB                              0x8627
#define GL_PROGRAM_FORMAT_ARB                              0x8876
#define GL_PROGRAM_BINDING_ARB                             0x8677
#define GL_PROGRAM_INSTRUCTIONS_ARB                        0x88A0
#define GL_MAX_PROGRAM_INSTRUCTIONS_ARB                    0x88A1
#define GL_PROGRAM_NATIVE_INSTRUCTIONS_ARB                 0x88A2
#define GL_MAX_PROGRAM_NATIVE_INSTRUCTIONS_ARB             0x88A3
#define GL_PROGRAM_TEMPORARIES_ARB                         0x88A4
#define GL_MAX_PROGRAM_TEMPORARIES_ARB                     0x88A5
#define GL_PROGRAM_NATIVE_TEMPORARIES_ARB                  0x88A6
#define GL_MAX_PROGRAM_NATIVE_TEMPORARIES_ARB              0x88A7
#define GL_PROGRAM_PARAMETERS_ARB                          0x88A8
#define GL_MAX_PROGRAM_PARAMETERS_ARB                      0x88A9
#define GL_PROGRAM_NATIVE_PARAMETERS_ARB                   0x88AA
#define GL_MAX_PROGRAM_NATIVE_PARAMETERS_ARB               0x88AB
#define GL_PROGRAM_ATTRIBS_ARB                             0x88AC
#define GL_MAX_PROGRAM_ATTRIBS_ARB                         0x88AD
#define GL_PROGRAM_NATIVE_ATTRIBS_ARB                      0x88AE
#define GL_MAX_PROGRAM_NATIVE_ATTRIBS_ARB                  0x88AF
#define GL_PROGRAM_ADDRESS_REGISTERS_ARB                   0x88B0
#define GL_MAX_PROGRAM_ADDRESS_REGISTERS_ARB               0x88B1
#define GL_PROGRAM_NATIVE_ADDRESS_REGISTERS_ARB            0x88B2
#define GL_MAX_PROGRAM_NATIVE_ADDRESS_REGISTERS_ARB        0x88B3
#define GL_MAX_PROGRAM_LOCAL_PARAMETERS_ARB                0x88B4
#define GL_MAX_PROGRAM_ENV_PARAMETERS_ARB                  0x88B5
#define GL_PROGRAM_UNDER_NATIVE_LIMITS_ARB                 0x88B6

//Accepted by the <pname> parameter of GetProgramStringARB:

#define GL_PROGRAM_STRING_ARB                              0x8628

//Accepted by the <pname> parameter of GetBooleanv, GetIntegerv,
//GetGLfloatv, and GetGLdoublev:

#define GL_PROGRAM_ERROR_POSITION_ARB                      0x864B
#define GL_CURRENT_MATRIX_ARB                              0x8641
#define GL_TRANSPOSE_CURRENT_MATRIX_ARB                    0x88B7
#define GL_CURRENT_MATRIX_STACK_DEPTH_ARB                  0x8640
#define GL_MAX_VERTEX_ATTRIBS_ARB                          0x8869
#define GL_MAX_PROGRAM_MATRICES_ARB                        0x862F
#define GL_MAX_PROGRAM_MATRIX_STACK_DEPTH_ARB              0x862E

//Accepted by the <name> parameter of GetString:

#define GL_PROGRAM_ERROR_STRING_ARB                        0x8874

//Accepted by the <mode> parameter of MatrixMode:

#define GL_MATRIX0_ARB                                     0x88C0
#define GL_MATRIX1_ARB                                     0x88C1
#define GL_MATRIX2_ARB                                     0x88C2
#define GL_MATRIX3_ARB                                     0x88C3
#define GL_MATRIX4_ARB                                     0x88C4
#define GL_MATRIX5_ARB                                     0x88C5
#define GL_MATRIX6_ARB                                     0x88C6
#define GL_MATRIX7_ARB                                     0x88C7
#define GL_MATRIX8_ARB                                     0x88C8
#define GL_MATRIX9_ARB                                     0x88C9
#define GL_MATRIX10_ARB                                    0x88CA
#define GL_MATRIX11_ARB                                    0x88CB
#define GL_MATRIX12_ARB                                    0x88CC
#define GL_MATRIX13_ARB                                    0x88CD
#define GL_MATRIX14_ARB                                    0x88CE
#define GL_MATRIX15_ARB                                    0x88CF
#define GL_MATRIX16_ARB                                    0x88D0
#define GL_MATRIX17_ARB                                    0x88D1
#define GL_MATRIX18_ARB                                    0x88D2
#define GL_MATRIX19_ARB                                    0x88D3
#define GL_MATRIX20_ARB                                    0x88D4
#define GL_MATRIX21_ARB                                    0x88D5
#define GL_MATRIX22_ARB                                    0x88D6
#define GL_MATRIX23_ARB                                    0x88D7
#define GL_MATRIX24_ARB                                    0x88D8
#define GL_MATRIX25_ARB                                    0x88D9
#define GL_MATRIX26_ARB                                    0x88DA
#define GL_MATRIX27_ARB                                    0x88DB
#define GL_MATRIX28_ARB                                    0x88DC
#define GL_MATRIX29_ARB                                    0x88DD
#define GL_MATRIX30_ARB                                    0x88DE
#define GL_MATRIX31_ARB                                    0x88DF

//Function types.
typedef void (APIENTRY *PFNGLVERTEXATTRIB1SARB)(GLuint index, GLshort x);
typedef void (APIENTRY *PFNGLVERTEXATTRIB1FARB)(GLuint index, GLfloat x);
typedef void (APIENTRY *PFNGLVERTEXATTRIB1DARB)(GLuint index, GLdouble x);
typedef void (APIENTRY *PFNGLVERTEXATTRIB2SARB)(GLuint index, GLshort x, GLshort y);
typedef void (APIENTRY *PFNGLVERTEXATTRIB2FARB)(GLuint index, GLfloat x, GLfloat y);
typedef void (APIENTRY *PFNGLVERTEXATTRIB2DARB)(GLuint index, GLdouble x, GLdouble y);
typedef void (APIENTRY *PFNGLVERTEXATTRIB3SARB)(GLuint index, GLshort x, GLshort y, GLshort z);
typedef void (APIENTRY *PFNGLVERTEXATTRIB3FARB)(GLuint index, GLfloat x, GLfloat y, GLfloat z);
typedef void (APIENTRY *PFNGLVERTEXATTRIB3DARB)(GLuint index, GLdouble x, GLdouble y, GLdouble z);
typedef void (APIENTRY *PFNGLVERTEXATTRIB4SARB)(GLuint index, GLshort x, GLshort y, GLshort z, GLshort w);
typedef void (APIENTRY *PFNGLVERTEXATTRIB4FARB)(GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
typedef void (APIENTRY *PFNGLVERTEXATTRIB4DARB)(GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w);
typedef void (APIENTRY *PFNGLVERTEXATTRIB4NUBARB)(GLuint index, GLubyte x, GLubyte y, GLubyte z, GLubyte w);

typedef void (APIENTRY *PFNGLVERTEXATTRIB1SVARB)(GLuint index, const GLshort *v);
typedef void (APIENTRY *PFNGLVERTEXATTRIB1FVARB)(GLuint index, const GLfloat *v);
typedef void (APIENTRY *PFNGLVERTEXATTRIB1DVARB)(GLuint index, const GLdouble *v);
typedef void (APIENTRY *PFNGLVERTEXATTRIB2SVARB)(GLuint index, const GLshort *v);
typedef void (APIENTRY *PFNGLVERTEXATTRIB2FVARB)(GLuint index, const GLfloat *v);
typedef void (APIENTRY *PFNGLVERTEXATTRIB2DVARB)(GLuint index, const GLdouble *v);
typedef void (APIENTRY *PFNGLVERTEXATTRIB3SVARB)(GLuint index, const GLshort *v);
typedef void (APIENTRY *PFNGLVERTEXATTRIB3FVARB)(GLuint index, const GLfloat *v);
typedef void (APIENTRY *PFNGLVERTEXATTRIB3DVARB)(GLuint index, const GLdouble *v);
typedef void (APIENTRY *PFNGLVERTEXATTRIB4BVARB)(GLuint index, const GLbyte *v);
typedef void (APIENTRY *PFNGLVERTEXATTRIB4SVARB)(GLuint index, const GLshort *v);
typedef void (APIENTRY *PFNGLVERTEXATTRIB4IVARB)(GLuint index, const GLint *v);
typedef void (APIENTRY *PFNGLVERTEXATTRIB4UBVARB)(GLuint index, const GLubyte *v);
typedef void (APIENTRY *PFNGLVERTEXATTRIB4USVARB)(GLuint index, const GLushort *v);
typedef void (APIENTRY *PFNGLVERTEXATTRIB4UIVARB)(GLuint index, const GLuint *v);
typedef void (APIENTRY *PFNGLVERTEXATTRIB4FVARB)(GLuint index, const GLfloat *v);
typedef void (APIENTRY *PFNGLVERTEXATTRIB4DVARB)(GLuint index, const GLdouble *v);
typedef void (APIENTRY *PFNGLVERTEXATTRIB4NBVARB)(GLuint index, const GLbyte *v);
typedef void (APIENTRY *PFNGLVERTEXATTRIB4NSVARB)(GLuint index, const GLshort *v);
typedef void (APIENTRY *PFNGLVERTEXATTRIB4NIVARB)(GLuint index, const GLint *v);
typedef void (APIENTRY *PFNGLVERTEXATTRIB4NUBVARB)(GLuint index, const GLubyte *v);
typedef void (APIENTRY *PFNGLVERTEXATTRIB4NUSVARB)(GLuint index, const GLushort *v);
typedef void (APIENTRY *PFNGLVERTEXATTRIB4NUIVARB)(GLuint index, const GLuint *v);

typedef void (APIENTRY *PFNGLVERTEXATTRIBPOINTERARB)(GLuint index, GLint size, GLenum type, GLboolean normalized, GLsizei stride,  const void *pointer);
typedef void (APIENTRY *PFNGLENABLEVERTEXATTRIBARRAYARB)(GLuint index);
typedef void (APIENTRY *PFNGLDISABLEVERTEXATTRIBARRAYARB)(GLuint index);
typedef void (APIENTRY *PFNGLPROGRAMSTRINGARB)(GLenum target, GLenum format, GLsizei len, const void *string); 
typedef void (APIENTRY *PFNGLBINDPROGRAMARB)(GLenum target, GLuint program);
typedef void (APIENTRY *PFNGLDELETEPROGRAMSARB)(GLsizei n, const GLuint *programs);
typedef void (APIENTRY *PFNGLGENPROGRAMSARB)(GLsizei n, GLuint *programs);

typedef void (APIENTRY *PFNGLPROGRAMENVPARAMETER4DARB)(GLenum target, GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w);
typedef void (APIENTRY *PFNGLPROGRAMENVPARAMETER4DVARB)(GLenum target, GLuint index, const GLdouble *params);
typedef void (APIENTRY *PFNGLPROGRAMENVPARAMETER4FARB)(GLenum target, GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
typedef void (APIENTRY *PFNGLPROGRAMENVPARAMETER4FVARB)(GLenum target, GLuint index, const GLfloat *params);

typedef void (APIENTRY *PFNGLPROGRAMLOCALPARAMETER4DARB)(GLenum target, GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w);
typedef void (APIENTRY *PFNGLPROGRAMLOCALPARAMETER4DVARB)(GLenum target, GLuint index, const GLdouble *params);
typedef void (APIENTRY *PFNGLPROGRAMLOCALPARAMETER4FARB)(GLenum target, GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
typedef void (APIENTRY *PFNGLPROGRAMLOCALPARAMETER4FVARB)(GLenum target, GLuint index, const GLfloat *params);

typedef void (APIENTRY *PFNGLGETPROGRAMENVPARAMETERDVARB)(GLenum target, GLuint index, GLdouble *params);
typedef void (APIENTRY *PFNGLGETPROGRAMENVPARAMETERFVARB)(GLenum target, GLuint index, GLfloat *params);

typedef void (APIENTRY *PFNGLGETPROGRAMLOCALPARAMETERDVARB)(GLenum target, GLuint index, GLdouble *params);
typedef void (APIENTRY *PFNGLGETPROGRAMLOCALPARAMETERFVARB)(GLenum target, GLuint index, GLfloat *params);

typedef void (APIENTRY *PFNGLGETPROGRAMIVARB)(GLenum target, GLenum pname, GLint *params);
typedef void (APIENTRY *PFNGLGETPROGRAMSTRINGARB)(GLenum target, GLenum pname, void *string);

typedef void (APIENTRY *PFNGLGETVERTEXATTRIBDVARB)(GLuint index, GLenum pname, GLdouble *params);
typedef void (APIENTRY *PFNGLGETVERTEXATTRIBFVARB)(GLuint index, GLenum pname, GLfloat *params);
typedef void (APIENTRY *PFNGLGETVERTEXATTRIBIVARB)(GLuint index, GLenum pname, GLint *params);
typedef void (APIENTRY *PFNGLGETVERTEXATTRIBPOINTERVARB)(GLuint index, GLenum pname, void **pointer);
typedef GLboolean (APIENTRY *PFNGLISPROGRAMARB)(GLuint program);

extern PFNGLVERTEXATTRIB1SARB glVertexAttrib1sARB;
extern PFNGLVERTEXATTRIB1FARB glVertexAttrib1fARB;
extern PFNGLVERTEXATTRIB1DARB glVertexAttrib1dARB;
extern PFNGLVERTEXATTRIB2SARB glVertexAttrib2sARB;
extern PFNGLVERTEXATTRIB2FARB glVertexAttrib2fARB;
extern PFNGLVERTEXATTRIB2DARB glVertexAttrib2dARB;
extern PFNGLVERTEXATTRIB3SARB glVertexAttrib3sARB;
extern PFNGLVERTEXATTRIB3FARB glVertexAttrib3fARB;
extern PFNGLVERTEXATTRIB3DARB glVertexAttrib3dARB;
extern PFNGLVERTEXATTRIB4SARB glVertexAttrib4sARB;
extern PFNGLVERTEXATTRIB4FARB glVertexAttrib4fARB;
extern PFNGLVERTEXATTRIB4DARB glVertexAttrib4dARB;
extern PFNGLVERTEXATTRIB4NUBARB glVertexAttrib4NubARB;

extern PFNGLVERTEXATTRIB1SVARB glVertexAttrib1svARB;
extern PFNGLVERTEXATTRIB1FVARB glVertexAttrib1fvARB;
extern PFNGLVERTEXATTRIB1DVARB glVertexAttrib1dvARB;
extern PFNGLVERTEXATTRIB2SVARB glVertexAttrib2svARB;
extern PFNGLVERTEXATTRIB2FVARB glVertexAttrib2fvARB;
extern PFNGLVERTEXATTRIB2DVARB glVertexAttrib2dvARB;
extern PFNGLVERTEXATTRIB3SVARB glVertexAttrib3svARB;
extern PFNGLVERTEXATTRIB3FVARB glVertexAttrib3fvARB;
extern PFNGLVERTEXATTRIB3DVARB glVertexAttrib3dvARB;
extern PFNGLVERTEXATTRIB4BVARB glVertexAttrib4bvARB;
extern PFNGLVERTEXATTRIB4SVARB glVertexAttrib4svARB;
extern PFNGLVERTEXATTRIB4IVARB glVertexAttrib4ivARB;
extern PFNGLVERTEXATTRIB4UBVARB glVertexAttrib4ubvARB;
extern PFNGLVERTEXATTRIB4USVARB glVertexAttrib4usvARB;
extern PFNGLVERTEXATTRIB4UIVARB glVertexAttrib4uivARB;
extern PFNGLVERTEXATTRIB4FVARB glVertexAttrib4fvARB;
extern PFNGLVERTEXATTRIB4DVARB glVertexAttrib4dvARB;
extern PFNGLVERTEXATTRIB4NBVARB glVertexAttrib4NbvARB;
extern PFNGLVERTEXATTRIB4NSVARB glVertexAttrib4NsvARB;
extern PFNGLVERTEXATTRIB4NIVARB glVertexAttrib4NivARB;
extern PFNGLVERTEXATTRIB4NUBVARB glVertexAttrib4NubvARB;
extern PFNGLVERTEXATTRIB4NUSVARB glVertexAttrib4NusvARB;
extern PFNGLVERTEXATTRIB4NUIVARB glVertexAttrib4NuivARB;

extern PFNGLVERTEXATTRIBPOINTERARB glVertexAttribPointerARB;
extern PFNGLENABLEVERTEXATTRIBARRAYARB glEnableVertexAttribArrayARB;
extern PFNGLDISABLEVERTEXATTRIBARRAYARB glDisableVertexAttribArrayARB;
extern PFNGLPROGRAMSTRINGARB glProgramStringARB;
extern PFNGLBINDPROGRAMARB glBindProgramARB;
extern PFNGLDELETEPROGRAMSARB glDeleteProgramsARB;
extern PFNGLGENPROGRAMSARB glGenProgramsARB;

extern PFNGLPROGRAMENVPARAMETER4DARB glProgramEnvParameter4dARB;
extern PFNGLPROGRAMENVPARAMETER4DVARB glProgramEnvParameter4dvARB;
extern PFNGLPROGRAMENVPARAMETER4FARB glProgramEnvParameter4fARB;
extern PFNGLPROGRAMENVPARAMETER4FVARB glProgramEnvParameter4fvARB;

extern PFNGLPROGRAMLOCALPARAMETER4DARB glProgramLocalParameter4dARB;
extern PFNGLPROGRAMLOCALPARAMETER4DVARB glProgramLocalParameter4dvARB;
extern PFNGLPROGRAMLOCALPARAMETER4FARB glProgramLocalParameter4fARB;
extern PFNGLPROGRAMLOCALPARAMETER4FVARB glProgramLocalParameter4fvARB;

extern PFNGLGETPROGRAMENVPARAMETERDVARB glGetProgramEnvParameterdvARB;
extern PFNGLGETPROGRAMENVPARAMETERFVARB glGetProgramEnvParameterfvARB;

extern PFNGLGETPROGRAMLOCALPARAMETERDVARB glGetProgramLocalParameterdvARB;
extern PFNGLGETPROGRAMLOCALPARAMETERFVARB glGetProgramLocalParameterfvARB;

extern PFNGLGETPROGRAMIVARB glGetProgramivARB;
extern PFNGLGETPROGRAMSTRINGARB glGetProgramStringARB;
extern PFNGLGETVERTEXATTRIBDVARB glGetVertexAttribdvARB;
extern PFNGLGETVERTEXATTRIBFVARB glGetVertexAttribfvARB;
extern PFNGLGETVERTEXATTRIBIVARB glGetVertexAttribivARB;
extern PFNGLGETVERTEXATTRIBPOINTERVARB glGetVertexAttribPointervARB;
extern PFNGLISPROGRAMARB glIsProgramARB;

// GL_ARB_fragment_program
#define GL_FRAGMENT_PROGRAM_ARB                                 0x8804
#define GL_PROGRAM_ALU_INSTRUCTIONS_ARB                         0x8805
#define GL_PROGRAM_TEX_INSTRUCTIONS_ARB                         0x8806
#define GL_PROGRAM_TEX_INDIRECTIONS_ARB                         0x8807
#define GL_PROGRAM_NATIVE_ALU_INSTRUCTIONS_ARB                  0x8808
#define GL_PROGRAM_NATIVE_TEX_INSTRUCTIONS_ARB                  0x8809
#define GL_PROGRAM_NATIVE_TEX_INDIRECTIONS_ARB                  0x880A
#define GL_MAX_PROGRAM_ALU_INSTRUCTIONS_ARB                     0x880B
#define GL_MAX_PROGRAM_TEX_INSTRUCTIONS_ARB                     0x880C
#define GL_MAX_PROGRAM_TEX_INDIRECTIONS_ARB                     0x880D
#define GL_MAX_PROGRAM_NATIVE_ALU_INSTRUCTIONS_ARB              0x880E
#define GL_MAX_PROGRAM_NATIVE_TEX_INSTRUCTIONS_ARB              0x880F
#define GL_MAX_PROGRAM_NATIVE_TEX_INDIRECTIONS_ARB              0x8810
#define GL_MAX_TEXTURE_COORDS_ARB                               0x8871
#define GL_MAX_TEXTURE_IMAGE_UNITS_ARB                          0x8872

//Some functions to initialize the extensions
bool check_extension( const char *ext );
bool init_vertex_program_arb();
bool init_separate_stencil_ati();
bool init_stencil_two_side_ext();
bool init_fragment_program_arb();
bool init_multitexture_arb();
bool init_compiled_vertex_array_ext();

#ifdef __cplusplus
}
#endif

#endif /* __glext_h_ */
