#ifndef __GLOBALS__
#define __GLOBALS__

#pragma warning(disable:4244)   // No warnings on precision truncation
#pragma warning(disable:4305)   // No warnings on precision truncation
#pragma warning(disable:4786)   // Remove stl warnings

#include <windows.h>
#include <gl\gl.h>

#include "log.h"

#pragma warning(disable:4786) 

typedef unsigned int uint32;
typedef int int32;
typedef unsigned short uint16;
typedef short int16;
typedef unsigned char uint8;
typedef char int8;

enum { EASY = 0, HARD };

// Main menu constants
enum { MENU_PLAY = 0, MENU_RESUME, MENU_OPTIONS, MENU_SCORES, MENU_EXIT };

// Options menu constants
enum { OPTION_DIFF = 0, OPTION_SHADOWS, OPTION_FS, OPTION_RES, OPTION_FILTER, OPTION_GEOMETRY };

// Invasion Console vars
extern char con_res[ 64 ];
extern int gScreenWidth, gScreenHeight;

extern bool con_fullscreen;

extern float con_block_size;   // Castle block size
extern bool con_ai;

extern int con_sndfx_vol;
extern char con_level[ 64 ];

extern bool con_wire;

extern bool con_draw_debug;
extern bool con_wincursor;

extern float con_znear;
extern float con_zfar;

extern int con_ship_health;
extern int con_num_start_ships;

extern int con_warmup_time;
extern int con_battle_time;
extern int con_build_time;
extern int con_cannon_time;

extern int con_difficulty;
extern int con_difficulty_next;

// Time between ship shots
extern float con_ship_shoot_count;
extern float con_cannon_shoot_time;

extern bool con_debug;

extern bool con_shadows;
extern bool con_light;
extern int con_geometry;

extern bool con_wake;

extern int con_filtering;

extern float gFactTick;
extern int gWireFrame;
extern unsigned int gClear;

extern bool gCompressTex;
extern bool gVertexProgram;

extern bool gSeparateStencilATI;
extern bool gStencilTwoSideEXT;

extern bool gGameOn;

extern int gCrosshairTexture;
extern int gParticleTexture;
extern int gZMGLogoTexture;
extern int gLogoTexture;

extern const float PI_OVER_180;
extern const float TWO_PI;
extern const float _180_OVER_PI;

#endif
