#ifndef __GUI__
#define __GUI__

#include <assert.h>

#include "textures.h"
#include "glext.h"
#include "log.h"
#include "globals.h"

class texture_manager_t;

class gui_obj_t
{
public:
  gui_obj_t() : mEnabled( false ) {}
  virtual ~gui_obj_t() {}

  void init( texture_manager_t *apTextures );
  
  void set_enable( bool aEnabled ) { mEnabled = aEnabled; }
  bool is_enabled() { return mEnabled; }
  
  virtual void reset();

  virtual void draw() = 0;
  virtual void handle_left_mouse() = 0;
  virtual void handle_right_mouse() = 0;
  
private:

  bool mEnabled;
};

#endif
