#ifndef __LIGHT__
#define __LIGHT__

#include <windows.h>
#include <gl\gl.h>
#include <assert.h>

#include "log.h"
#include "globals.h"
#include "vect3.h"

class light_t
{
public:
  light_t() : mEnable( false ) {}
	~light_t() {}

  void enable() { mEnable = true; }
  bool get_enable() const { return mEnable; }

  void set_pos( const float *lPos ) 
  { 
    mPos[ 0 ] = lPos[ 0 ];
    mPos[ 1 ] = lPos[ 1 ];
    mPos[ 2 ] = lPos[ 2 ];
    mPos[ 3 ] = lPos[ 3 ];
  }

  void set_spot_pos( const float *aPos ) 
  { 
    mSpotPos[ 0 ] = aPos[ 0 ];
    mSpotPos[ 1 ] = aPos[ 1 ];
    mSpotPos[ 2 ] = aPos[ 2 ];
  }

  void set_color( const float *lColor ) 
  { 
    mColor[ 0 ] = lColor[ 0 ];
    mColor[ 1 ] = lColor[ 1 ];
    mColor[ 2 ] = lColor[ 2 ];
    mColor[ 3 ] = lColor[ 3 ];
  }

  float *get_pos() { return mPos; }
  float *get_spot_pos() { return mSpotPos; }
  float *get_color() { return mColor; }

private:

  bool mEnable;
  float mPos[ 4 ];
  float mSpotPos[ 3 ];
  float mColor[ 4 ];
};


#endif