#ifndef __MENU__
#define __MENU__

#pragma warning(disable:4244)   // No warnings on precision truncation
#pragma warning(disable:4305)   // No warnings on precision truncation
#pragma warning(disable:4786)   // Remove stl warnings

#include <vector>
#include <string>

#include <windows.h>
#include <GL/gl.h>
#include <GL/glu.h>

#include <assert.h>

#include "fmath.h"
#include "globals.h"
#include "font.h"
#include "qsound.h"
#include "score_list.h"

using namespace std;

class menu_sys_t
{
public: 
	menu_sys_t( font_t *apFont, sound_manager_t *apSound );
	~menu_sys_t() {}

	void add_entry( const char *aEntry ) { mEntries.push_back( aEntry ); }
  void set_entry( int aNum, const string &aEntry );
  void set_curr_entry( int aEntry );

	void draw();
	void draw_scores();
  void draw_options();

	void key_up();
	void key_down();
	int get_entry() const;
  const string &get_entry_string() const;

	bool is_enabled() const { return mEnabled; }
	void enable() { mEnabled = true; }
	void disable() { mEnabled = false; }

  bool in_progress() { return mGameStarted; }
  void set_game_started( bool aGameStarted ) { mGameStarted = aGameStarted; }

private:

	bool mEnabled;
  bool mGameStarted;    // Used to determine if a game has ever been started
	int mCurrEntry;
	vector<string> mEntries;

	font_t *mpFont;
	sound_manager_t *mpSound;

	int mSwitchSound;
	int mClickSound;
};

#endif