#include "misc.h"

char *
COM_SkipPath( char *pathname )
{
  char	*last;
  
  last = pathname;
  while ( *pathname )
  {
    if ( *pathname == '/' )
      last = pathname + 1;
    pathname++;
  }
  return last;
}

void 
COM_StripExtension( const char *in, char *out )
{
  while ( *in && *in != '.' )
    *out++ = *in++;
  *out = 0;
}

char *
COM_FileExtension( const char *in )
{
  static char exten[ 8 ];
  int i;
  
  while ( *in && *in != '.' )
    in++;
  if ( !*in )
    return "";
  in++;
  for ( i = 0 ; i < 7 && *in; i++, in++ )
    exten[ i ] = tolower( *in );
  exten[ i ] = 0;
  return exten;
}

unsigned long 
COM_FileSize( FILE *fp )
{
	fseek( fp, 0, SEEK_END );
	unsigned long size = ftell( fp );
	fseek( fp, 0, SEEK_SET );
	return size;
}

unsigned long 
COM_FileSize( const char *name )
{
	FILE *fp = fopen( name, "r" );
	if ( !fp )
	{
		printf( "Cannot open file %s\n", name );
		return 0;
	}

	return COM_FileSize( fp );
}

void
putint( FILE *fp, int val )
{
  putc( val & 0xff, fp );
  putc( ( val & 0xff00 ) >> 8, fp );
  putc( ( val & 0xff0000 ) >> 16, fp );
  putc( ( val & 0xff000000 ) >> 24, fp );
}

void
putshort( FILE *fp, short val )
{
  putc( val & 0xff, fp );
  putc( ( val & 0xff00 ) >> 8, fp );
}

unsigned int 
getint( FILE *fp )
{
  int c, c1, c2, c3;

  // get 4 bytes
  c = getc(fp);  
  c1 = getc(fp);  
  c2 = getc(fp);  
  c3 = getc(fp);
  
  return ((unsigned int) c) +   
    (((unsigned int) c1) << 8) + 
    (((unsigned int) c2) << 16) +
    (((unsigned int) c3) << 24);
}

unsigned int 
getshort( FILE *fp )
{
  int c, c1;
  
  //get 2 bytes
  c = getc(fp);  
  c1 = getc(fp);

  return ((unsigned int) c) + (((unsigned int) c1) << 8);
}