#ifndef __MODEL_NODE__
#define __MODEL_NODE__

#include "model.h"

////////////////////////////////////////////////////////////////////////
class model_node_t
{
public:
	model_node_t();
	~model_node_t() {}

	void set_model( model_t *apModel ) { mpModel = apModel; }
	void set_shader( shader_t *apShader );
	void set_texture( int aTexture ) { mTexture = aTexture; }
  void set_pos( const vect3_t &lPos ) { mPos = lPos; }
  const vect3_t &get_pos() const { return mPos; }

	void draw();
	void draw_lines();
  void draw_pos();

  const sphere_t &get_sphere() const { return mpModel->get_sphere(); }
  void get_box( vect3_t &aMin, vect3_t &aMax ) const 
    { mpModel->get_box( aMin, aMax ); }

private:

  // Shader Stuff
	void draw_shader();
	void update_shader_pass( int aNum );
  void transform_vertices();
  //

	model_t *mpModel;

	int mTexture;

	shader_t *mpShader;

	// Data for each shader pass
	vector<PolyPassData> mShaderData;

  vect3_t mPos;
};

#endif