#include "modellist.h"

model_t *
model_manager_t::insert( const char *apName, float aScale )
{
	// Check wether we've loaded this model already
	for ( int i = 0; i < mModels.size(); i++ )
	{
		if ( mModels[ i ]->get_name() == apName )
			return mModels[ i ];
	}
  
	model_t *lpModel = new model_t;
	assert( lpModel );

	bool lStatus = lpModel->load( apName, aScale );

  if ( !lStatus )
  {
    delete lpModel;
    return NULL;
  }

	mModels.push_back( lpModel );
	return lpModel;
}

shadow_model_t *
model_manager_t::insert_shadow( const char *apName, float aScale )
{
	// Check wether we've loaded this model already
	for ( int i = 0; i < mShadowModels.size(); i++ )
	{
		if ( mShadowModels[ i ]->get_name() == apName )
			return mShadowModels[ i ];
	}
  
	shadow_model_t *lpModel = new shadow_model_t;
	assert( lpModel );

	bool lStatus = lpModel->load( apName, aScale );

  if ( !lStatus )
  {
    delete lpModel;
    return NULL;
  }

	mShadowModels.push_back( lpModel );
	return lpModel;
}
