#ifndef __MODEL_MANAGER__
#define __MODEL_MANAGER__

#include <vector>
#include <assert.h>

#include "textures.h"
#include "model.h"
#include "shadow_model.h"
#include "log.h"

//////////////////////////////////////////////////
// class model_manager_t
//////////////////////////////////////////////////
class model_manager_t
{
public:
	model_manager_t() {}

	~model_manager_t() 
  {     
    clear();
  }

	void clear() 
	{
    int i;
		for ( i = 0; i < mModels.size(); i++ )
			delete mModels[ i ];

		mModels.clear(); 

		for ( i = 0; i < mShadowModels.size(); i++ )
			delete mShadowModels[ i ];

		mShadowModels.clear(); 
	}

	model_t *insert( const char *apName, float aScale = 1 );
  shadow_model_t *insert_shadow( const char *apName, float aScale = 1 );

private:

	vector<model_t*> mModels;
  vector<shadow_model_t*> mShadowModels;
};

#endif
