#ifndef __PROGRAM__
#define __PROGRAM__

#include <stdlib.h>
#include <stdio.h>
#include <windows.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <string>
#include <list>
#include <vector>

#include "glext.h"
#include "misc.h"
#include "log.h"

class program_manager_t
{
public :
	program_manager_t() { reset(); }
	virtual ~program_manager_t() { reset(); }

	int insert( const char *aFileName, GLenum aProgType );

private :
	void reset() 
  {
    for ( int i = 0; i < mIDs.size(); ++i )
      glDeleteProgramsARB( 1, &( mIDs[ i ] ) );
    mIDs.clear(); 
  }

	vector<unsigned int> mIDs;
};

#endif