
#ifndef __QSOUND__
#define __QSOUND__

#include <stdio.h>
#include <windows.h>
#include <mmsystem.h>

#include "log.h"
#include "console.h"
#include "qmixer.h"
#include "globals.h"
#include "vect3.h"

#define QMDX

class sound_manager_t
{
public:

  sound_manager_t() { init(); }
  ~sound_manager_t() { shut_down(); }

  int load_sample( char *apFileName );
  void free_sample( int aSampleID );

  int play_sample( int aSampleID, float aVolume, float aPan );
  void stop_sample( int aSampleID );
  void stop_all();

  int play_sample3d( int aSampleID, const float *apPos, int aLoop = 0 );
  int play_sample( int aSampleID, int aLoop = 0 );

  void set_listener( const float *apPos, const float *apDir );

  void set_sample_volume( int aSampleID, int aVolume );

  void set_volume( int aVolume );

  void set_sample_pos( int aSampleID, const float *apPos );
  
  enum { MAX_SAMPLES = 200 };
  enum { MAX_VOLUME = 32767 };

private:

  int init();
  void shut_down();
  
  struct sample_t
  {
    LPMIXWAVE mSample;
  	int mChannel;
	  char mName[ MAX_SAMPLES ];
  };

  vect3_t mListenPos;
  
  sample_t mSamples[ 200 ];
  int mSampleCount;

  HQMIXER mQMixer;
};

#endif
