#include "slider.h"

///////////////////////////////////////////////////////////////
slider_t::slider_t() : mEnabled( false ), mTextureBG( -1 ), mTextureSlider( -1 ), mSliderPos( 0 )
{  
}

///////////////////////////////////////////////////////////////
slider_t::~slider_t()
{
}

///////////////////////////////////////////////////////////////
void
slider_t::init( texture_manager_t *apTextures )
{
  assert( apTextures );

  mTextureBG = apTextures->insert( "sliderbg.jpg" );
  mTextureSlider = apTextures->insert( "sliderptr.jpg" );
}

///////////////////////////////////////////////////////////////
void
slider_t::set_window_dimensions( int aX0, int aX1, int aZ0, int aZ1 )
{
  mWX0 = aX0;
  mWX1 = aX1;
  mWZ0 = aZ0;
  mWZ1 = aZ1;

  mRange = aX1 - aX0;
}

///////////////////////////////////////////////////////////////
void
slider_t::set_slider_dimensions( int aX0, int aX1, int aZ0, int aZ1 )
{
  mSX0 = aX0;
  mSX1 = aX1;
  mSZ0 = aZ0;
  mSZ1 = aZ1;
}

///////////////////////////////////////////////////////////////
void
slider_t::draw()
{
  if ( !mEnabled )
    return;

	glBindTexture( GL_TEXTURE_2D, mTextureBG );
	glBegin( GL_QUADS );
  
	glTexCoord2f( 0, 0 );
	glVertex2f( mWX0, mWZ0 );
  
	glTexCoord2f( 0, 1 );
	glVertex2f( mWX0, mWZ1 );
  
	glTexCoord2f( 1, 1 );
	glVertex2f( mWX1, mWZ1 );
  
	glTexCoord2f( 1, 0 );
	glVertex2f( mWX1, mWZ0 );

	glEnd();
}