#ifndef __SLIDER__
#define __SLIDER__

#include <assert.h>

#include "textures.h"
#include "glext.h"
#include "log.h"
#include "globals.h"

class texture_manager_t;

class slider_t
{
public:
	slider_t();
	virtual ~slider_t();

  void init( texture_manager_t *apTextures );
  
  void enable() { mEnabled = true; }
  bool is_enabled() { return mEnabled; }
  void reset();

  void draw();
  void handle_left_mouse();

  void set_value( int aValue );
  void set_window_dimensions( int aX0, int aX1, int aZ0, int aZ1 );
  void set_slider_dimensions( int aX0, int aX1, int aZ0, int aZ1 );
  void set_slider_pos( int aPos ) { mSliderPos = 0; }
  int get_slider_pos() const { return mSliderPos; }
  
private:

  bool mEnabled;

  int mTextureBG;
  int mTextureSlider;

  int mWX0, mWX1, mWZ0, mWZ1;
  int mSX0, mSX1, mSZ0, mSZ1;
  int mRange;
  int mSliderPos;
};

#endif
