#ifndef __TEXTBOX_H__
#define __TEXTBOX_H__

#include <windows.h>
#include <GL/gl.h>
#include <GL/glu.h>

#include "globals.h"
#include "font.h"


enum { TEXT_WIDTH = 16 };

//////////////////////////////////////////////////////////////////////
// Use this class to present a typeable text box to the player
//////////////////////////////////////////////////////////////////////
class textbox_t  
{
public:
	textbox_t();
	~textbox_t();

  void enable() { mEnabled = true; }
  bool is_enabled() { return mEnabled; }
  void reset();
  bool add_char( unsigned short aKey );
  bool add( unsigned short aKey );
  void draw_text( font_t *apFont, int aX, int aY );
  void get_text( char aText[] );

private:

  bool mEnabled;
  char mTextInput[ TEXT_WIDTH ];

  int mCursorPos;
  int mMaxPos;
  int mCursorCount;

};

extern textbox_t *gpNameTextBox;

#endif
